datablock ParticleData(LightningStingTrailParticle)
{
	dragCoefficient      = 0.0;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0;
	lifetimeMS           = 300;		//150
	lifetimeVarianceMS   = 20;
	textureName          = "add-ons/projectile_radio_wave/bolt";
	spinSpeed		= 10;
	spinRandomMin		= 2;
	spinRandomMax		= 2;
	colors[0]     = "0.5 0.6 1 1";
	colors[1]     = "0.0 0.0 1 0.0";

	sizes[0]      = 0.8;	//0.4
	sizes[1]      = 0.2;
	
	times[0] = 0;
	times[1] = 1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(LightningStingTrailEmitter)
{
   ejectionPeriodMS = 1;	//5
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset   = 0.05;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "LightningStingTrailParticle";

   uiName = "MSA Sting Trail";
//   emitterNode = TenthEmitterNode;
};

datablock ParticleData(LightningStingExplosionParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 20;
	textureName          = "add-ons/projectile_radio_wave/bolt";
	spinSpeed			= 10;
	spinRandomMin		= 8;
	spinRandomMax		= 8;
	colors[0]     = "0.9 0.9 1 1";
	colors[1]     = "0.2 0.2 1 0.3";

	sizes[0]      = 0.5;
	sizes[1]      = 0.3;
	
	times[0] = 0;
	times[1] = 1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(LightningStingExplosionEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 5;	//10
   velocityVariance = 2;
   ejectionOffset   = 0.1;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "LightningStingExplosionParticle";

   uiName = "MSA Sting Explosion";
//   emitterNode = TenthEmitterNode;
};

/////////////////
//--Explosion--//
/////////////////
datablock ExplosionData(LightningStingExplosion)
{
   //explosionShape = "";
   explosionShape = "";
	soundProfile = radioWaveExplosionSound;

	lifeTimeMS = 300;	//70

	particleEmitter = LightningStingExplosionEmitter;
	particleDensity = 30;	//10
	particleRadius = 0.2;
		 

//   emitter[0] = LightningStingExplosionEmitter;
//   emitter[1] = LightningStingExplosionFlareEmitter;

//   debris = LightningStingFlareDebris;
//   debrisNum = 50;
//   debrisNumVariance = 10;
//   debrisPhiMin = 0;
//   debrisPhiMax = 360;
//   debrisThetaMin = 0;
//   debrisThetaMax = 180;
//   debrisVelocity = 120;
//   debrisVelocityVariance = 30;
   
   faceViewer = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 10.0 8.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.2;
   camShakeRadius = 2.0;

   // Dynamic light
   lightStartRadius = 6;
   lightEndRadius = 2;
   lightStartColor = "0.7 0.7 1 1";
   lightEndColor = "0.2 0.2 1 0";

   damageRadius = 7;	//3
   radiusDamage = 40;	//30

   impulseRadius = 6;	//3
   impulseForce = 1000;
};


AddDamageType("LightningStingDirect",   '<bitmap:add-ons/Weapon_BugZapper/CI_zap> %1',    '%2 <bitmap:add-ons/Weapon_BugZapper/CI_zap> %1',1,1);
//AddDamageType("LightningStingRadius",   '<bitmap:add-ons/Weapon_Rocket_Launcher/CI_rocketRadius> %1',    '%2 <bitmap:add-ons/Weapon_Rocket_Launcher/CI_rocketRadius> %1',1,0);
datablock ProjectileData(LightningStingProjectile)
{
   projectileShapeName	= "base/data/shapes/empty.dts";
   directDamage			= 50;	//30
//   vsMechDamage			= 1;
//   vsSmallEnemyDamage	= 15;
//   vsLargeEnemyDamage	= 2;
   directDamageType = $DamageType::LightningStingDirect;
   radiusDamageType = $DamageType::LightningStingDirect;
   impactImpulse	   = 0;
   verticalImpulse	   = 0;
   explosion           = LightningStingExplosion;
   particleEmitter     = LightningStingTrailEmitter;

   brickExplosionRadius = 2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 4;             
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

//   sound = LightningStingLoopSound;

   muzzleVelocity      = 200;	//200
   velInheritFactor    = 0;

   armingDelay         = 0;
   lifetime            = 120;	//100
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0;

   hasLight    = true;
   lightRadius = 4;
   lightColor  = "0.8 0.8 1";

   uiName = "MAS Lightning Sting";
};

//////////
// item //
//////////
datablock ItemData(LightningStingItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "base/data/shapes/empty.dts";
	rotate = false;
	mass = 1;
	density = 0.2;

	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "MAS Lightning Stinger";
	iconName = "";
	doColorShift = false;
	colorShiftColor = "0.100 0.500 0.250 1.000";

	 // Dynamic properties defined by the scripts
	image = CtrlLightningStingImage;
	canDrop = false;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(CtrlLightningStingImage)
{
   // Basic Item properties
//   shapeFile = "base/data/shapes/empty.dts";
   shapeFile = "add-ons/weapon_gun/pistol.dts";
   emap = true;

   doColorShift = false;
   colorShiftColor = "0.100 0.500 0.250 1.000";

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = LightningStingProjectile;
//   projectile = "";
   projectileType = Projectile;

	//casing = rocketLauncherShellDebris;
//	shellExitDir        = "1.0 -1.3 1.0";
//	shellExitOffset     = "0 0 0";
//	shellExitVariance   = 15.0;	
//	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   minShotTime = 500;   //minimum time allowed between shots (needed to prevent equip/dequip exploit)

   //casing = " ";`

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.1;
	stateTransitionOnTimeout[0]		 = "Ready";
//	stateSound[0]					 = weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
//	stateSequence[1]				 = "root";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]            = 0.01;
//	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
//	stateSequence[2]                = "charge";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= false;
//	stateEmitter[2]					= OrbTrailEmitter;
//	stateEmitterTime[2]				= 0.2;
//	stateEmitterNode[2]				= "muzzleNode";
//	stateSound[2]					= radioWaveExplosionSound;
	stateTransitionOnTriggerUp[2]     = "Reload";

	stateName[3]					= "Reload";
	stateAllowImageChange[3]        = true;
	stateTimeoutValue[3]            = 0.5;
	stateWaitForTimeout[3]			= true;
	stateTransitionOnTimeout[3]     = "Ready";

};

datablock ShapeBaseImageData(MainLightningStingImage)
{
   // Basic Item properties
//   shapeFile = "base/data/shapes/empty.dts";
   shapeFile = "add-ons/weapon_gun/pistol.dts";
   emap = true;

   doColorShift = false;
   colorShiftColor = "0.100 0.500 0.250 1.000";

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 1;	//6
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = LightningStingProjectile;
   projectileType = Projectile;

	//casing = rocketLauncherShellDebris;
//	shellExitDir        = "1.0 -1.3 1.0";
//	shellExitOffset     = "0 0 0";
//	shellExitVariance   = 15.0;	
//	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = false;
   minShotTime = 500;   //minimum time allowed between shots (needed to prevent equip/dequip exploit)
	energyUsage = 140;

   //casing = " ";`

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.1;
	stateTransitionOnTimeout[0]		 = "Ready";
//	stateSound[0]					 = weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
//	stateSequence[1]				 = "root";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]            = 0.1;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
//	stateSequence[2]                = "charge";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
//	stateEmitter[2]					= LightningStingExplosion;
//	stateEmitterTime[2]				= 0.2;
//	stateEmitterNode[2]				= "muzzleNode";
//	stateSound[2]					= radioWaveExplosionSound;

	stateName[3]					= "Reload";
//	stateSequence[4]                = "Reload";
	stateAllowImageChange[3]        = false;
//	stateTimeoutValue[3]            = 0.01;
//	stateWaitForTimeout[3]			= true;
//	stateTransitionOnTimeout[3]     = "Ready";
	stateTransitionOnTriggerUp[3]     = "Ready";
};

function CtrlLightningStingImage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
   //mount lefthanded gun
   %obj.mountImage(MainLightningStingImage, 1);
//   %obj.playThread(1, armreadyboth);
}
function CtrlLightningStingImage::onFire(%this,%obj,%slot)
{
	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
		return;
	%obj.setImageTrigger(1,1);
	Parent::onFire(%this,%obj,%slot);
//	%obj.setImageTrigger(6,0);
}
function CtrlLightningStingImage::onUnMount(%this, %obj, %slot)
{
   Parent::onUnMount(%this, %obj, %slot);
   //unmount lefthanded gun
   %obj.unMountImage(1);
   //%obj.playThread(0, root);
}

function MainLightningStingImage::onFire(%this, %obj, %slot)
{
	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
		return;
	%obj.lastFireTime = getSimTime();

	if(%obj.getEnergyLevel() >= %this.energyUsage)
	{
		%obj.setEnergyLevel(%obj.getEnergyLevel() - %this.energyUsage);

		%obj.playThread(3, Sting);
		serverPlay3D(radioWaveExplosionSound,%obj.getPosition());

		Parent::onFire(%this, %obj, %slot);   
	}
}
function MainLightningStingImage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
   %obj.playThread(1, armreadyboth);
}
function MainLightningStingImage::onUnMount(%this, %obj, %slot)
{
   Parent::onUnMount(%this, %obj, %slot);
   %obj.playThread(1, root);
}
