//akimbogun.cs

//datablock AudioProfile(ASNprotoLaserFireSound1)
//{
//	filename    = "./ProtoLaserfire1.wav";
//	description = AudioDefault3d;
//	preload = true;
//};

datablock ParticleData(ASNprotoLaserBeamParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 400;	//350
	lifetimeVarianceMS   = 50;
	textureName          = "base/data/particles/star1";
	spinSpeed			= 550.0;
	spinRandomMin		= 0.0;
	spinRandomMax		= 0.0;
	colors[0]     = "0.4 0.4 1.0 0.1";
	colors[1]     = "0.3 0.0 1.0 0.2";
	colors[2]     = "0.1 0.0 0.3 0.0";
	sizes[0]      = 0.9;	//0.87
	sizes[1]      = 0.93;	//0.9
	sizes[2]      = 0.4;	//0.8
	times[0]	= 0;
	times[1]	= 0.15;
	times[2]	= 1;

	useInvAlpha = false;
};

datablock ParticleEmitterData(ASNprotoLaserBeamTrailEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 50;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ASNprotoLaserBeamParticle"; //ASNprotoLaserTrailParticle";

   uiName = "MAS Proto Beam";
};

//datablock ParticleEmitterData(ASNprotoLaserExplosionEmitter)
//{
//   ejectionPeriodMS = 5;
//   periodVarianceMS = 1;
//   ejectionVelocity = 4;	
//   velocityVariance = 2;
//   ejectionOffset   = 1;	//2
//   thetaMin         = 0;
//   thetaMax         = 50;
//   phiReferenceVel  = 0;
//   phiVariance      = 360;
//   overrideAdvance = false;
//   particles = "ASNprotoLaserParticle"; //ASNprotoLaserTrailParticle";

//   uiName = "";
//};

datablock ExplosionData(ASNprotoLaserBeamExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 150;

   soundProfile = vehicleExplosionSound;
   
//   emitter[0] = vehicleFinalExplosionEmitter3;
//   emitter[1] = vehicleFinalExplosionEmitter2;

   particleEmitter = ASNprotoLaserExplosionEmitter;
   particleDensity = 70;
   particleRadius = 0.5;	//1

//	subExplosion[0] = MASinterceptorFanExplosion;

//   debris = MASinterceptorDebris;
//   debrisNum = 1;
//   debrisNumVariance = 0;
//   debrisPhiMin = 0;
//   debrisPhiMax = 360;
//   debrisThetaMin = 0;
//   debrisThetaMax = 50;
//   debrisVelocity = 15;
//   debrisVelocityVariance = 3;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 14.0 10.0";
   camShakeAmp = "3.0 3.0 3.0";
   camShakeDuration = 1.8;
   camShakeRadius = 4.0;

   // Dynamic light
   lightStartRadius = 10;
   lightEndRadius = 0;
   lightStartColor = "0.6 0.0 1.0";
   lightEndColor = "0.0 0 1.0";

   //impulse
   impulseRadius = 500;
   impulseForce = 3;
//   impulseVertical = 0;

   //radius damage
   radiusDamage        = 20;
   damageRadius        = 3;

   //burn the players?
//   playerBurnTime = 5000;

};

//we'll only get this far if we actually have the gun add-on
//  so it's safe to directly use stuff from that
//AddDamageType(<name>, <suicide message>, <kill message>, <vehicle damage scale>, <is direct damage>);
//AddDamageType("ASNprotoLaser",   '<bitmap:add-ons/Weapon_Guns_Akimbo/CI_2guns> %1',    '%2 <bitmap:add-ons/Weapon_Guns_Akimbo/CI_2guns> %1',0.05,1);
datablock ProjectileData(ASNprotoLaserBeamProjectile)
{
//   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 85;	//75
   directDamageType    = $DamageType::ASNprotoLaser;
   radiusDamageType    = $DamageType::ASNprotoLaser;

   brickExplosionRadius = 4;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 3;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 6;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   explosion           = ASNprotoLaserBeamExplosion;
   particleEmitter     = ASNprotoLaserBeamTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 0;

   armingDelay         = 00;
   lifetime            = 6000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 2.0;
   lightColor  = "0.45 0 1";

   uiName = "MAS ProtoBeam";
};

//////////
// item //
//////////
datablock ItemData(ASNprotoLaserBeamItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
//	shapeFile = "Add-Ons/Weapon_Gun/pistol.dts";
	shapeFile = "base/data/shapes/empty.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "MAS Proto Beam";
	iconName = "./Icon_ProtoBeam";
	doColorShift = false;
	colorShiftColor = "0.1 0.1 0.2 1.000";

	 // Dynamic properties defined by the scripts
	image = ASNprotoLaserBeamImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(ASNprotoLaserBeamImage)
{
   // Basic Item properties
//   shapeFile = "Add-Ons/Weapon_Gun/pistol.dts";
	shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = ASNprotoLaserBeamProjectile;
   projectileType = Projectile;

//	casing = gunShellDebris;
//	shellExitDir        = "1.0 -1.3 1.0";
//	shellExitOffset     = "0 0 0";
//	shellExitVariance   = 15.0;	
//	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = false;

   doColorShift = false;
   colorShiftColor = ASNprotoLaserItem.colorShiftColor;//"0.400 0.196 0 1.000";

   minShotTime = 900;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "Ready";
	stateTimeoutValue[0] = 0.2;
//	stateSequence[0] = "ready";

	stateName[1] = "Ready";
//	stateSequence[1] = "ready";
	stateTransitionOnTriggerDown[1] = "Fire";

	stateName[2] = "Fire";
//	stateEjectShell[2]       = true;
//	stateSequence[2] = "Fire";
	stateTransitionOnTimeout[2] = "Reload";
	stateWaitForTimeout[2] = true;
	stateTimeoutValue[2] = 1;		//0.8
	stateFire[2] = true;
	stateAllowImageChange[2] = false;
	stateScript[2] = "onFire";
//	stateSound[2] = gunShot1Sound;
//   stateEmitter[2]					= gunFlashEmitter;
//	stateEmitterTime[2]				= 0.05;
//	stateEmitterNode[2]				= "muzzleNode";

//   stateName[3] = "Smoke";
//	stateEmitter[3]					= gunSmokeEmitter;
//	stateEmitterTime[3]				= 0.05;
//	stateEmitterNode[3]				= "muzzleNode";
//	stateTimeoutValue[3]            = 0.01;
//	stateTransitionOnTimeout[3]     = "Reload";

	stateName[3] = "Reload";
	stateAllowImageChange[3] = false;
	stateTransitionOnTriggerUp[3] = "Ready";
//	stateSequence[3] = "ready";

//	stateName[5] = "FireAkimbo";
//	stateTimeoutValue[5] = 0.09;
//	stateScript[5] = "onFireAkimbo";
//	stateTransitionOnTimeOut[5] = "ready";
};


//function ASNprotoLaserImage::onFireAkimbo(%this,%obj,%slot)
//{
//   %obj.setImageTrigger(1,1);
//}


datablock ShapeBaseImageData(ASNprotoLaserBeamCannonImage)
{
   // Basic Item properties
//   shapeFile = "Add-Ons/Weapon_Gun/pistol.dts";
	shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 7;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = ASNprotoLaserBeamProjectile;
   projectileType = Projectile;

//	casing = gunShellDebris;
//	shellExitDir        = "1.0 -1.3 1.0";
//	shellExitOffset     = "0 0 0";
//	shellExitVariance   = 15.0;	
//	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = false;

	energyUsage = 60;	//30

   doColorShift = false;
//   colorShiftColor = ASNprotoLaserItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0] = "Activate";
	stateTransitionOnTimeout[0] = "Ready";
	stateTimeoutValue[0] = 0.2;
	stateSequence[0] = "ready";
//   stateSound[0]		= weaponSwitchSound;

	stateName[1] = "Ready";
	stateSequence[1] = "ready";
	stateTransitionOnTriggerDown[1] = "Fire";

	stateName[2] = "Fire";
	stateEjectShell[2]       = true;
	stateTransitionOnTimeout[2] = "Reload";
	stateWaitForTimeout[2] = true;
	stateTimeoutValue[2] = 0.01;
	stateFire[2] = true;
	stateAllowImageChange[2] = false;
	stateScript[2] = "onFire";
//	stateSound[2] = ASNprotoLaserFireSound1;
//	stateEmitter[2]					= gunFlashEmitter;
//	stateEmitterTime[2]				= 0.05;
//	stateEmitterNode[2]				= "muzzleNode";

//	stateName[3] = "Fire2";
//	stateEjectShell[3]       = true;
//	stateTransitionOnTimeout[3] = "Fire3";
//	stateWaitForTimeout[3] = true;
//	stateTimeoutValue[3] = 0.095;
//	stateFire[3] = true;
//	stateAllowImageChange[3] = false;
//	stateScript[3] = "onFire";
////	stateSound[3] = ASNprotoLaserFireSound1;
////	stateEmitter[3]					= gunFlashEmitter;
////	stateEmitterTime[3]				= 0.05;
////	stateEmitterNode[3]				= "muzzleNode";

//	stateName[4] = "Fire3";
//	stateEjectShell[4]       = true;
//	stateTransitionOnTimeout[4] = "Fire4";
//	stateWaitForTimeout[4] = true;
//	stateTimeoutValue[4] = 0.095;
//	stateFire[4] = true;
//	stateAllowImageChange[4] = false;
//	stateScript[4] = "onFire";
////	stateSound[4] = ASNprotoLaserFireSound1;
////	stateEmitter[4]					= gunFlashEmitter;
////	stateEmitterTime[4]				= 0.05;
////	stateEmitterNode[4]				= "muzzleNode";

//	stateName[5] = "Fire4";
//	stateEjectShell[5]       = true;
//	stateTransitionOnTimeout[5] = "Reload";
//	stateWaitForTimeout[5] = true;
//	stateTimeoutValue[5] = 0.3;
//	stateFire[5] = true;
//	stateAllowImageChange[5] = false;
//	stateScript[5] = "onFire";
////	stateSound[5] = ASNprotoLaserFireSound1;
////	stateEmitter[5]					= gunFlashEmitter;
////	stateEmitterTime[5]				= 0.05;
////	stateEmitterNode[5]				= "muzzleNode";

	stateName[3] = "Reload";
	stateAllowImageChange[3] = false;
	stateTransitionOnTriggerUp[3] = "Ready";
	stateSequence[3] = "ready";


};

function ASNprotoLaserBeamCannonImage::onFire(%this, %obj, %slot)
{
	if(%obj.getEnergyLevel() >= %this.energyUsage)
	{
//		if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
//			return;
//		%obj.lastFireTime = getSimTime();
      
//		%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%obj.client.player.getEyeVector(),"-3")));

		%obj.playThread(2, shiftAway);
		%obj.setEnergyLevel(%obj.getEnergyLevel() - %this.energyUsage);
		serverPlay3D(ASNprotoLaserFireSound1,%obj.getPosition());

		Parent::onFire(%this,%obj,%slot);

//		%projectile = %this.projectile;
//		%spread = 0.0008;	//0.0015
//		%shellcount = 1;	//8

//		for(%shell=0; %shell<%shellcount; %shell++)
//		{
//			%vector = %obj.getMuzzleVector(%slot);
//			%objectVelocity = %obj.getVelocity();
//			%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
//			%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
//			%velocity = VectorAdd(%vector1,%vector2);
//			%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
//			%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
//			%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
//			%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
//			%velocity = MatrixMulVector(%mat, %velocity);

//			%p = new (%this.projectileType)()
//			{
//				dataBlock = %projectile;
//				initialVelocity = %velocity;
//				initialPosition = %obj.getMuzzlePoint(%slot);
//				sourceObject = %obj;
//				sourceSlot = %slot;
//				client = %obj.client;
//			};
//			MissionCleanup.add(%p);
//		}
//		return %p;
	}
	else
	{
		bottomprint(%obj.client,"<color:ffffff>You are low on energy" ,2);
	}
}

function ASNprotoLaserBeamImage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
   //mount lefthanded gun
   %obj.mountImage(ASNprotoLaserBeamCannonImage, 1);
   //%obj.playThread(0, armreadyboth);
}
function ASNprotoLaserBeamImage::onUnMount(%this, %obj, %slot)
{
   Parent::onUnMount(%this, %obj, %slot);
   //unmount lefthanded gun
   %obj.unMountImage(1);
   //%obj.playThread(0, root);
}


function ASNprotoLaserBeamCannonImage::onMount(%this, %obj, %slot)
{
   Parent::onMount(%this, %obj, %slot);
//   %obj.playThread(1, armreadyboth);
}
function ASNprotoLaserBeamCannonImage::onUnMount(%this, %obj, %slot)
{
   Parent::onUnMount(%this, %obj, %slot);
}

function ASNprotoLaserBeamImage::onFire(%this,%obj,%slot)
{
	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
		return;
	%obj.lastFireTime = getSimTime();
	%obj.setImageTrigger(1,1);
//	if(%obj.getDamagePercent() < 1.0)
//		%obj.playThread(2, shiftAway);
//	Parent::onFire(%this,%obj,%slot);	
}
