datablock ParticleEmitterData(ASNdamageEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 2;
   ejectionVelocity = 6;
   velocityVariance = 2.0;
   ejectionOffset   = 1.2;
   thetaMin         = 0;
   thetaMax         = 160;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "radioWaveExplosionParticle";

   useEmitterColors = true;

   uiName = "ASN Damage";
};

datablock ShapeBaseImageData(ASNdamageImage)
{
   // Basic Item properties
	shapeFile = "base/data/shapes/empty.dts";

   emap = true;

   doColorShift = true;
   colorShiftColor = "0.65 0.8 1.0 0.500";

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 5;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = "";
   projectileType = Projectile;

	//casing = rocketLauncherShellDebris;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = false;
   minShotTime = 0;   //minimum time allowed between shots (needed to prevent equip/dequip exploit)

   //casing = " ";`

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.01;
	stateTransitionOnTimeout[0]       = "Effect";
	stateAllowImageChange[0]         = true;

	stateName[1]                     = "Effect";
	stateAllowImageChange[1]         = true;
	stateEmitter[1]					= ASNdamageEmitter;
	stateEmitterTime[1]				= 0.10;
	stateTimeoutValue[1]             = 0.10;
	stateTransitionOnTimeout[1]       = "Done";

	stateName[2]                     = "Done";
	stateScript[2]					 = "onDone";

};

function ASNdamageImage::onDone(%this,%obj,%slot)
{
	%obj.unmountImage(%slot);
//	%obj.playThread(2, shiftAway);
//	Parent::onDone(%this,%obj,%slot);	
}
